/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.fleet.machine.tree;

import java.util.ArrayList;
import java.util.List;
import nl.cloudfarming.client.fleet.model.Machine;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;

/**
 * FilterNode.Children extention class which filters children on
 * presence of a Class<? extends Machine> machineClass in their lookup
 * 
 * @author Timon Veenstra <monezz@gmail.com>
 */
public class MachineCategoryChildren extends FilterNode.Children {

    private final Class<? extends Machine> machineClass;
    
    public MachineCategoryChildren(Node node, Class<? extends Machine> machineClass) {
        super(node);
        this.machineClass = machineClass;
    }

        @Override
    protected Node[] createNodes(Node object) {
        List<Node> result = new ArrayList<>();

        for (Node node : super.createNodes(object)) {
            if (accept(node)) {
                result.add(node);
            }
        }
        return result.toArray(new Node[0]);
    }

    private boolean accept(Node node) {
//        return node.getLookup().lookup(machineClass) != null;
        return true;
    }
}
